<script lang="ts">
  import { GetScoringPeriodsPoints } from '@models/Service';
  import { eventId } from '@stores';

  export let edit = false;

  async function TableData(eventId: string) {
    const scoringInfo = await GetScoringPeriodsPoints(eventId);
    let ret = new Map<string, { name: string; points: number; description: string; check_id: string }>();
    for (const period of scoringInfo) {
      for (const entry of period?.points || []) {
        if (ret.has(entry.check.id)) {
          ret.set(entry.check.id, {
            check_id: entry.check.id,
            name: entry.check.display_name,
            points: ret.get(entry.check.id)!.points + entry.points,
            description: entry.check.description,
          });
        } else {
          ret.set(entry.check.id, {
            check_id: entry.check.id,
            name: entry.check.display_name,
            points: entry.points,
            description: entry.check.description,
          });
        }
      }
    }
    return ret;
  }
</script>

{#await TableData($eventId)}
  <p>Loading...</p>
{:then info}
  <div class="row text-white table pt-2">
    <!-- THEAD -->
    <h4 class="col-3 d-inline-block">Service</h4>
    <h4 class="col-2 d-inline-block">Points</h4>
    <h4 class="col-7 d-inline-block">Description</h4>
  </div>
  {#each [...info.values()] as row}
    <a class="row text-white hover text-decoration-none p-1" href="/scoring/checks/{row.check_id}{edit ? '/edit' : ''}">
      <div class="col-3">{row.name}</div>
      <div class="col-2">{row.points}</div>
      <div class="col-7">{row.description || 'No description provided'}</div>
    </a>
  {/each}
{:catch e}
  <p>Could not load scoring information!</p>
{/await}
